<app-modal mods="theme-yellow, content-center"
           [title]="title" [subtitle]="subtitle" (close)="close()">
  <form action="#" class="form form--no-margin"
        autocomplete="off"
        [formGroup]="form"
        (submit)="onSubmit()"
  >
    <div *ngIf="type === 'product'" class="form__step" [@stepOne]="currentStep">
          <div class="form__fieldset">
            <div *ngIf="products" class="form__field">
              <label [for]="FormControlName.GoodsType" class="form__label form__label--light"
                     [class.form__label--invalid]="form.get(FormControlName.GoodsType)?.invalid && form.get(FormControlName.GoodsType)?.touched">
                Тип бензина
                <sup class="form__required"
                     *ngIf="form.get(FormControlName.GoodsType)?.errors && form.get(FormControlName.GoodsType)?.hasError('required')">*</sup>
              </label>
<!--              [items]="products"-->
              <app-select
                  [formControlName]="FormControlName.GoodsType"
                  [invalid]="(form.get(FormControlName.GoodsType)?.invalid
                  && form.get(FormControlName.GoodsType)?.touched)"
                  mods="no-shadow"
              >
                <app-loader *ngIf="!products.length" mods="sm, yellow"></app-loader>
              </app-select>
            </div>
            <div class="form__field">
              <label [for]="FormControlName.Count" class="form__label form__label--light"
                     [class.form__label--invalid]="form.get(FormControlName.Count)?.invalid && form.get(FormControlName.Count)?.touched">
                Сколько литров?
                <sup class="form__required"
                     *ngIf="form.get(FormControlName.Count)?.errors && form.get(FormControlName.Count)?.hasError('required')">*</sup>
              </label>
              <app-input
                [id]="FormControlName.Count"
                type="text"
                [formControlName]="FormControlName.Count"
                [invalid]="(form.get(FormControlName.Count)?.invalid && form.get(FormControlName.Count)?.touched)"
              >
              </app-input>
            </div>
            <div class="form__field">
              <app-checkbox mods="md, inverted" [formControlName]="FormControlName.Delivery">
                <ng-container class="text">Нужна доставка?</ng-container>
              </app-checkbox>
            </div>
            <ng-container *ngIf="form.get(FormControlName.Delivery)?.valueChanges | async" formGroupName="delivery-group">
              <div class="form__field">
                <label [for]="FormControlName.Date" class="form__label form__label--light"
                       [class.form__label--invalid]="form.get('delivery-group')?.get(FormControlName.Date)?.invalid
                       && form.get('delivery-group')?.get(FormControlName.Date)?.touched">Время доставки
                  <sup class="form__required"
                       *ngIf="form.get('delivery-group')?.get(FormControlName.Date)?.errors
                       && form.get('delivery-group')?.get(FormControlName.Date)?.hasError('required')">*</sup>
                </label>
                <app-datepicker
                  [formControlName]="FormControlName.Date"
                  [invalid]="form.get('delivery-group')?.get(FormControlName.Date)?.invalid
                  && form.get('delivery-group')?.get(FormControlName.Date)?.touched"
                  mods="no-shadow">
<!--                  <ng-container class="errors">-->
<!--                    <small *ngIf="utils.getObjectKey(form.get('delivery-group').get(FormControlName.Date).errors).length">-->
<!--                      {{FormFieldError[utils.getObjectKey(form.get('delivery-group').get(FormControlName.Date).errors)[0]]}}-->
<!--                    </small>-->
<!--                  </ng-container>-->
                </app-datepicker>
              </div>
              <div class="form__field">
                <label [for]="FormControlName.Address" class="form__label form__label--light"
                       [class.form__label--invalid]="form.get('delivery-group')?.get(FormControlName.Address)?.invalid
                       && form.get('delivery-group')?.get(FormControlName.Address)?.touched"
                >Адресс доставки
                  <sup class="form__required"
                       *ngIf="form.get('delivery-group')?.get(FormControlName.Address)?.errors
                       && form.get('delivery-group')?.get(FormControlName.Address)?.hasError('required')">*</sup>
                </label>
                <app-input
                  type="textarea"
                  [formControlName]="FormControlName.Address"
                  [invalid]="form.get('delivery-group')?.get(FormControlName.Address)?.invalid
                  && form.get('delivery-group')?.get(FormControlName.Address)?.touched"
                ></app-input>
              </div>
            </ng-container>
          </div>
    </div>
    <div class="form__step" [@stepTwo]="currentStep">
      <app-switcher name="user-type"
                    [items]="[
                    {id: 'individual', name: 'Физ. лицо', checked: true},
                    {id: 'entity', name: 'Юр. лицо'}]" (switch)="selectUserType($event)">
      </app-switcher>
      <div class="form__fieldset" formGroupName="personal">
        <div class="form__field">
          <label [for]="FormControlName.FirstName" class="form__label form__label--light">
            Как к Вам обращаться?
          </label>
          <app-input
            [id]="FormControlName.FirstName"
            type="text"
            [formControlName]="FormControlName.FirstName"
            [invalid]="(form.get('personal')?.get(FormControlName.FirstName)?.invalid
                 && form.get('personal')?.get(FormControlName.FirstName)?.touched)"
          >
<!--            <ng-container class="errors">-->
<!--              <small *ngIf="getObjectKey(form.get('personal')?.get(FormControlName.FirstName)?.errors).length">-->
<!--                {{FormFieldError[getObjectKey(form.get('personal')?.get(FormControlName.FirstName)?.errors)[0]]}}-->
<!--              </small>-->
<!--            </ng-container>-->
          </app-input>
        </div>
        <div *ngIf="entity" class="form__field">
          <label [for]="FormControlName.FirstName" class="form__label form__label--light">
            Название фирмы
          </label>
          <app-input
            [id]="FormControlName.FirstName"
            type="text"
            [formControlName]="FormControlName.FirstName"
            [invalid]="(form.get('personal')?.get(FormControlName.FirstName)?.invalid
                 && form.get('personal')?.get(FormControlName.FirstName)?.touched)"
          >
<!--            <ng-container class="errors">-->
<!--              <small *ngIf="utils.getObjectKey(form.get('personal').get(FormControlName.FirstName).errors).length">-->
<!--                {{FormFieldError[utils.getObjectKey(form.get('personal').get(FormControlName.FirstName).errors)[0]]}}-->
<!--              </small>-->
<!--            </ng-container>-->
          </app-input>
        </div>
        <div class="form__field">
          <label [for]="FormControlName.Email" class="form__label form__label--light">
            Эл. почта
          </label>
          <app-input
            [type]="FormFieldMeta[FormControlName.Email].type"
            [id]="FormControlName.Email"
            [formControlName]="FormControlName.Email"
            [mask]="FormFieldMeta[FormControlName.Email].mask"
            [prefix]="FormFieldMeta[FormControlName.Email].prefix"
            [showMaskTyped]="FormFieldMeta[FormControlName.Email].showMaskTyped"
            [inputmode]="FormFieldMeta[FormControlName.Email].inputmode"
            [invalid]="(form.get('personal')?.get(FormControlName.Email)?.invalid
                 && form.get('personal')?.get(FormControlName.Email)?.touched)"
          >
            <!--        <ng-container class="errors">-->
            <!--          <small *ngIf="utils.getObjectKey(control.value.errors).length">-->
            <!--            {{FormFieldError[utils.getObjectKey(control.value.errors)[0]]}}-->
            <!--          </small>-->
            <!--        </ng-container>-->
          </app-input>
        </div>
        <div class="form__field">
          <label [for]="FormControlName.Count" class="form__label form__label--light">
            Телефон
          </label>
          <app-input
            [type]="FormFieldMeta[FormControlName.Tel].type"
            [id]="FormControlName.Tel"
            [formControlName]="FormControlName.Tel"
            [mask]="FormFieldMeta[FormControlName.Tel].mask"
            [prefix]="FormFieldMeta[FormControlName.Tel].prefix"
            [showMaskTyped]="FormFieldMeta[FormControlName.Tel].showMaskTyped"
            [inputmode]="FormFieldMeta[FormControlName.Tel].inputmode"
            [invalid]="(form.get('personal')?.get(FormControlName.Tel)?.invalid
                 && form.get('personal')?.get(FormControlName.Tel)?.touched)"
          >
            <!--        <ng-container class="errors">-->
            <!--          <small *ngIf="utils.getObjectKey(control.value.errors).length">-->
            <!--            {{FormFieldError[utils.getObjectKey(control.value.errors)[0]]}}-->
            <!--          </small>-->
            <!--        </ng-container>-->
          </app-input>
        </div>
        <div class="form__field">
          <label [for]="FormControlName.Message" class="form__label form__label--light">Сообщение</label>
          <app-input type="textarea" [formControlName]="FormControlName.Message"></app-input>
        </div>
      </div>
    </div>
    <div  *ngIf="type === 'product'" class="form__total">
      Заказ на сумму:
      <span>{{(form.get(FormControlName.GoodsType) && form.get(FormControlName.GoodsType)?.value || price)
      * form.get(FormControlName.Count)?.value | currency: 'RUB':'symbol-narrow':'1.0':'ru'}}</span>
    </div>
    <div class="form__actions">
      <app-btn type="button"  *ngIf="type === 'product'" (click)="goToStep(FormSteps.one)" [disabled]="currentStep === FormSteps.one">Назад</app-btn>
      <app-btn  *ngIf="(currentStep !== FormSteps.two) && (type === 'product')" type="button" (click)="goToStep(FormSteps.two)">Дальше</app-btn>
      <app-btn *ngIf="currentStep === FormSteps.two" type="submit">Отправить</app-btn>
<!--      <button type="button" class="btn btn--sm btn--prev btn--dark" ></button>-->
<!--      <button type="button" class="btn btn--sm btn--prev btn--dark" ></button>-->
<!--      <button type="submit" class="btn btn--sm btn--success" [disabled]="form.invalid">Отправить</button>-->
    </div>
  </form>
</app-modal>
